import { ObjectState } from './object-state';
import { IBuildable, ICleanable, IResetable, ObjectValues } from './types';
export declare class CollectionState<T> implements ICleanable, IResetable, IBuildable<T[]> {
    private _elements;
    constructor(elements: T[]);
    get elements(): ObjectState<T>[];
    get dirtyElements(): ObjectState<T>[];
    get errorElements(): ObjectState<T>[];
    get newElements(): ObjectState<T>[];
    get deletedElements(): ObjectState<T>[];
    get count(): number;
    get values(): ObjectValues<T>[];
    get(index: 0): ObjectState<T>;
    add(element: T): void;
    remove(element: ObjectState<T>): void;
    clean(): void;
    reset(): void;
    build(): T[];
    filter(fn: (element: ObjectValues<T>) => boolean): ObjectState<T>[];
    find(fn: (element: ObjectValues<T>) => boolean): ObjectState<T> | undefined;
    some(fn: (element: ObjectValues<T>) => boolean): boolean;
    clearErrors(): void;
}
