import StateValues from './state-values';
import { IBuildable, ICleanable, IErrors, IResetable, IState, IValues, ObjectProperties, ObjectValues } from './types';
export declare class PropertiesState<TObject> implements IState, IBuildable<TObject>, IValues<TObject>, ICleanable, IResetable, IErrors {
    private _properties;
    private _original;
    private _key;
    private _values;
    private _errors;
    get isDirty(): boolean;
    get key(): string;
    get values(): ObjectValues<TObject> & StateValues<TObject>;
    get errors(): string[];
    set errors(errors: string[]);
    get hasErrors(): boolean;
    constructor(key: string, obj: TObject, properties: ObjectProperties<TObject>);
    build(): TObject;
    clean(): void;
    reset(): void;
    clearErrors(): void;
}
